package fortyonepost.com.resetpreferencesdialog; // 41 Post - Created by DimasTheDriver on Aug/25/2012 . Part of the 'Android: reset to default preference dialog' post. Available at: http://www.41post.com/?p=4924.

import android.content.Intent;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

public class PrefsActivity extends PreferenceActivity 
{
	//A handle to the Preference that resets all values to their defaults.
	private Preference resetDialogPreference;
	//An intent object, that holds the intent that started this Activity.
	private Intent startIntent;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
		super.onCreate(savedInstanceState);
		//Inflate the preference screen entries from the 'activity_prefs.xml' file.
		addPreferencesFromResource(R.layout.activity_prefs);
		/* Set the default values by reading the "android:defaultValue"
		   attributes from each preference at the 'activity_prefs.xml' file. */
		PreferenceManager.setDefaultValues(this, R.layout.activity_prefs, false);
		
		//Initialize the preference object by obtaining a handle to the ResetDefDiagPref object as a Preference
		this.resetDialogPreference = getPreferenceScreen().findPreference("resetDialog");
		
		//Store the Intent that started this Activity at this.startIntent.
		this.startIntent = getIntent();
	
		//Set the OnPreferenceChangeListener for the resetDialogPreference
		this.resetDialogPreference.setOnPreferenceChangeListener(new OnPreferenceChangeListener() 
		{
			@Override
			public boolean onPreferenceChange(Preference preference, Object newValue) 
			{
				//Both enter and exit animations are set to zero, so no transition animation is applied
				overridePendingTransition(0, 0);
				//Call this line, just to make sure that the system doesn't apply an animation 
				startIntent.addFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
				//Close this Activity
				finish();
				//Again, don't set an animation for the transition
				overridePendingTransition(0, 0);
				//Start the activity by calling the Intent that have started this same Activity
				startActivity(startIntent);
				//Return false, so that nothing happens to the preference values
				return false;
			}
		});
    }
}